window.Gleam.initSearch([{"doc":"cleam","title":"cleam","content":"# cleam\n\n[![Package Version](https://img.shields.io/hexpm/v/cleam)](https://hex.pm/packages/cleam)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/cleam/)\n\n![logo](logo.png)\n\nCleam for clean Gleam. Detect unused exports, i.e. public functions, const and types, that not used in another files. \n\n## How to\n\n1. Add cleam to your project as dev dependency\n```sh\ngleam add cleam --dev\n```\n\n2. Run check locally or on CI/CD\n```sh\ngleam run -m cleam\n```\n","url":"index.html"},{"doc":"internal/fs","title":"FileContent","content":"pub type FileContent {\n  FileContent(String)\n}\n\nFileContent(String)\n\n\nSynonyms:\ninternal/fs.FileContent\ninternal/fs FileContent","url":"internal/fs.html#FileContent"},{"doc":"internal/fs","title":"FilePath","content":"pub type FilePath {\n  FilePath(String)\n}\n\nFilePath(String)\n\n\nSynonyms:\ninternal/fs.FilePath\ninternal/fs FilePath","url":"internal/fs.html#FilePath"},{"doc":"internal/fs","title":"FilesDir","content":"pub type FilesDir {\n  FilesDir(String)\n}\n\nFilesDir(String)\n\n\nSynonyms:\ninternal/fs.FilesDir\ninternal/fs FilesDir","url":"internal/fs.html#FilesDir"},{"doc":"internal/fs","title":"ModuleFullName","content":"pub type ModuleFullName {\n  ModuleFullName(String)\n}\n\nModuleFullName(String)\n\n\nSynonyms:\ninternal/fs.ModuleFullName\ninternal/fs ModuleFullName","url":"internal/fs.html#ModuleFullName"},{"doc":"internal/fs","title":"file_path_to_module_full_name","content":"pub fn file_path_to_module_full_name(\n  files_dir: FilesDir,\n  file_path: FilePath,\n) -&gt; ModuleFullName\n\nSynonyms:\ninternal/fs.file_path_to_module_full_name\ninternal/fs file_path_to_module_full_name","url":"internal/fs.html#file_path_to_module_full_name"},{"doc":"internal/fs","title":"files_contents","content":"pub fn files_contents(\n  files_paths: List(FilePath),\n) -&gt; List(FileContent)\n\nSynonyms:\ninternal/fs.files_contents\ninternal/fs files_contents","url":"internal/fs.html#files_contents"},{"doc":"internal/fs","title":"files_paths","content":"pub fn files_paths(dir: FilesDir) -&gt; List(FilePath)\n\nSynonyms:\ninternal/fs.files_paths\ninternal/fs files_paths","url":"internal/fs.html#files_paths"},{"doc":"internal/fs","title":"internal/fs","content":"","url":"internal/fs.html"},{"doc":"internal/ast","title":"AnotherFilesAst","content":"pub type AnotherFilesAst {\n  AnotherFilesAst(List(FileAst))\n}\n\nAnotherFilesAst(List(FileAst))\n\n\nSynonyms:\ninternal/ast.AnotherFilesAst\ninternal/ast AnotherFilesAst","url":"internal/ast.html#AnotherFilesAst"},{"doc":"internal/ast","title":"FileAst","content":"pub type FileAst {\n  FileAst(AST)\n}\n\nFileAst(AST)\n\n\nSynonyms:\ninternal/ast.FileAst\ninternal/ast FileAst","url":"internal/ast.html#FileAst"},{"doc":"internal/ast","title":"ModuleName","content":"pub type ModuleName {\n  ModuleName(String)\n}\n\nModuleName(String)\n\n\nSynonyms:\ninternal/ast.ModuleName\ninternal/ast ModuleName","url":"internal/ast.html#ModuleName"},{"doc":"internal/ast","title":"PublicMember","content":"pub type PublicMember {\n  PublicFun(String)\n  PublicConst(String)\n  PublicType(String)\n}\n\nPublicFun(String)\n\n\nPublicConst(String)\n\n\nPublicType(String)\n\n\nSynonyms:\ninternal/ast.PublicMember\ninternal/ast PublicMember","url":"internal/ast.html#PublicMember"},{"doc":"internal/ast","title":"files_ast","content":"pub fn files_ast(\n  files_contents: List(FileContent),\n) -&gt; List(FileAst)\n\nSynonyms:\ninternal/ast.files_ast\ninternal/ast files_ast","url":"internal/ast.html#files_ast"},{"doc":"internal/ast","title":"files_paths_with_ast","content":"pub fn files_paths_with_ast(\n  dir: FilesDir,\n  test_dir: Option(FilesDir),\n) -&gt; List(#(FilePath, FileAst, AnotherFilesAst))\n\nSynonyms:\ninternal/ast.files_paths_with_ast\ninternal/ast files_paths_with_ast","url":"internal/ast.html#files_paths_with_ast"},{"doc":"internal/ast","title":"is_pub_member_used","content":"pub fn is_pub_member_used(\n  files_ast: AnotherFilesAst,\n  pub_member_name: PublicMember,\n  module_full_name: ModuleFullName,\n  check_usage: fn(List(Statement), PublicMember, ModuleName) -&gt;\n    Result(Nil, a),\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ninternal/ast.is_pub_member_used\ninternal/ast is_pub_member_used","url":"internal/ast.html#is_pub_member_used"},{"doc":"internal/ast","title":"internal/ast","content":"","url":"internal/ast.html"},{"doc":"internal/ast_fun","title":"is_pub_fun_used","content":"pub fn is_pub_fun_used(\n  files_ast: AnotherFilesAst,\n  pub_fun_name: PublicMember,\n  module_full_name: ModuleFullName,\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ninternal/ast_fun.is_pub_fun_used\ninternal/ast_fun is_pub_fun_used","url":"internal/ast_fun.html#is_pub_fun_used"},{"doc":"internal/ast_fun","title":"public_funs","content":"pub fn public_funs(file_ast: FileAst) -&gt; List(PublicMember)\n\nSynonyms:\ninternal/ast_fun.public_funs\ninternal/ast_fun public_funs","url":"internal/ast_fun.html#public_funs"},{"doc":"internal/ast_fun","title":"internal/ast_fun","content":"","url":"internal/ast_fun.html"},{"doc":"internal/ast_const","title":"is_pub_const_used","content":"pub fn is_pub_const_used(\n  files_ast: AnotherFilesAst,\n  pub_const_name: PublicMember,\n  module_full_name: ModuleFullName,\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ninternal/ast_const.is_pub_const_used\ninternal/ast_const is_pub_const_used","url":"internal/ast_const.html#is_pub_const_used"},{"doc":"internal/ast_const","title":"public_const","content":"pub fn public_const(file_ast: FileAst) -&gt; List(PublicMember)\n\nSynonyms:\ninternal/ast_const.public_const\ninternal/ast_const public_const","url":"internal/ast_const.html#public_const"},{"doc":"internal/ast_const","title":"internal/ast_const","content":"","url":"internal/ast_const.html"},{"doc":"internal/ast_type","title":"is_pub_type_used","content":"pub fn is_pub_type_used(\n  files_ast: AnotherFilesAst,\n  pub_type_name: PublicMember,\n  module_full_name: ModuleFullName,\n) -&gt; Result(Nil, Nil)\n\nSynonyms:\ninternal/ast_type.is_pub_type_used\ninternal/ast_type is_pub_type_used","url":"internal/ast_type.html#is_pub_type_used"},{"doc":"internal/ast_type","title":"public_type","content":"pub fn public_type(file_ast: FileAst) -&gt; List(PublicMember)\n\nSynonyms:\ninternal/ast_type.public_type\ninternal/ast_type public_type","url":"internal/ast_type.html#public_type"},{"doc":"internal/ast_type","title":"internal/ast_type","content":"","url":"internal/ast_type.html"},{"doc":"internal/checker","title":"not_used_const","content":"pub fn not_used_const(\n  dir: FilesDir,\n  ast_info: List(#(FilePath, FileAst, AnotherFilesAst)),\n) -&gt; List(#(PublicMember, FilePath))\n\nSynonyms:\ninternal/checker.not_used_const\ninternal/checker not_used_const","url":"internal/checker.html#not_used_const"},{"doc":"internal/checker","title":"not_used_functions","content":"pub fn not_used_functions(\n  dir: FilesDir,\n  ast_info: List(#(FilePath, FileAst, AnotherFilesAst)),\n) -&gt; List(#(PublicMember, FilePath))\n\nSynonyms:\ninternal/checker.not_used_functions\ninternal/checker not_used_functions","url":"internal/checker.html#not_used_functions"},{"doc":"internal/checker","title":"not_used_types","content":"pub fn not_used_types(\n  dir: FilesDir,\n  ast_info: List(#(FilePath, FileAst, AnotherFilesAst)),\n) -&gt; List(#(PublicMember, FilePath))\n\nSynonyms:\ninternal/checker.not_used_types\ninternal/checker not_used_types","url":"internal/checker.html#not_used_types"},{"doc":"internal/checker","title":"internal/checker","content":"","url":"internal/checker.html"},{"doc":"cleam","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ncleam.main\ncleam main","url":"cleam.html#main"},{"doc":"cleam","title":"cleam","content":"","url":"cleam.html"}]);